-----------------------------------------------------------------------------------------------
-- Client Lua Script for Lucky
-- Copyright (c) NCsoft. All rights reserved
-----------------------------------------------------------------------------------------------
 
require "Window"
 
-----------------------------------------------------------------------------------------------
-- Lucky Module Definition
-----------------------------------------------------------------------------------------------
local Lucky = {} 
 
-----------------------------------------------------------------------------------------------
-- Constants
-----------------------------------------------------------------------------------------------
-- e.g. local kiExampleVariableMax = 999
 
-----------------------------------------------------------------------------------------------
-- Initialization
-----------------------------------------------------------------------------------------------
function Lucky:new(o)
    o = o or {}
    setmetatable(o, self)
    self.__index = self 

    -- initialize variables here

    return o
end

function Lucky:Init()
	local bHasConfigureFunction = false
	local strConfigureButtonText = ""
	local StartingAmountVAR = "0"
	local EndingAmountVAR	= "0"
	local AmountEarnedVAR	= "0"
	local tDependencies = {
		}
    Apollo.RegisterAddon(self, bHasConfigureFunction, strConfigureButtonText, tDependencies)
end
 

-----------------------------------------------------------------------------------------------
-- Lucky OnLoad
-----------------------------------------------------------------------------------------------
function Lucky:OnLoad()
    -- load our form file
	self.xmlDoc = XmlDoc.CreateFromFile("Lucky.xml")
	self.xmlDoc:RegisterCallback("OnDocLoaded", self)
end

-----------------------------------------------------------------------------------------------
-- Lucky OnDocLoaded
-----------------------------------------------------------------------------------------------
function Lucky:OnDocLoaded()

	if self.xmlDoc ~= nil and self.xmlDoc:IsLoaded() then
	    self.wndMain = Apollo.LoadForm(self.xmlDoc, "LuckyBastardForm", nil, self)
		if self.wndMain == nil then
			Apollo.AddAddonErrorText(self, "Could not load the main window for some reason.")
			return
		end
		
	    self.wndMain:Show(false, true)

		-- if the xmlDoc is no longer needed, you should set it to nil
		-- self.xmlDoc = nil
		
		-- Register handlers for events, slash commands and timer, etc.
		-- e.g. Apollo.RegisterEventHandler("KeyDown", "OnKeyDown", self)
		Apollo.RegisterSlashCommand("Lucky", "OnLuckyOn", self)
		Apollo.RegisterSlashCommand("lucky", "OnLuckyOn", self)
		Apollo.RegisterSlashCommand("lb", "OnLukcyOn", self)
		Apollo.RegisterSlashCommand("LB", "OnLuckyOn", self)


		-- Do additional Addon initialization here
	end
end

-----------------------------------------------------------------------------------------------
-- Lucky Functions
-----------------------------------------------------------------------------------------------
-- Define general functions here

-- on SlashCommand "/Lucky"
function Lucky:OnLuckyOn()
	self.wndMain:Invoke() -- show the window
end


-----------------------------------------------------------------------------------------------
-- LuckyForm Functions
-----------------------------------------------------------------------------------------------
-- when the START button is clicked
function Lucky:OnSTARTLB()
	CurrentAmount = GameLib.GetPlayerCurrency(Money.CodeEnumCurrencyType.Credits):GetAmount()
	self.wndMain:FindChild("Price"):SetAmount(CurrentAmount)
end

-- when the END button is clicked
function Lucky:OnEND()
	local CurrentVar = CurrentAmount
	local EndAmount = GameLib.GetPlayerCurrency(Money.CodeEnumCurrencyType.Credits):GetAmount()
	local AmountMade = 0
	
	if CurrentAmount < EndAmount then
		AmountMade = EndAmount - CurrentAmount
	end
	
	if CurrentAmount > EndAmount then
		AmountMade = CurrentAmount - EndAmount
		Print("Oops you have lost money")
	end
	
	if CurrentAmount == EndAmount then
		AmountMade = 0
	end
	self.wndMain:FindChild("PriceEnd"):SetAmount(EndAmount)
	self.wndMain:FindChild("PriceMade"):SetAmount(AmountMade)
end

function Lucky:OnCancel( wndHandler, wndControl, eMouseButton )
	self.wndMain:Close()
end

function Lucky:OnReset()
	self.wndMain:FindChild("Price"):SetAmount(0)
	self.wndMain:FindChild("PriceEnd"):SetAmount(0)
	self.wndMain:FindChild("PriceMade"):SetAmount(0)
end

-----------------------------------------------------------------------------------------------
-- Lucky Instance
-----------------------------------------------------------------------------------------------
local LuckyInst = Lucky:new()
LuckyInst:Init()
